<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';
require FORUM_ROOT.'extensions/pan_board/functions.php';

($hook = get_hook('abrd_start')) ? eval($hook) : null;

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language file
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_forums.php';

$action = isset($_GET['action']) ? $_GET['action'] : null;
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

// Add new Board
if (isset($_POST['add_cat']))
{
	$add_to_cat = isset($_POST['add_to_cat']) ? intval($_POST['add_to_cat']) : 0;
	$cat_name = forum_trim($_POST['cat_name']);
	$position = intval($_POST['position']);

	($hook = get_hook('abrd_add_cat_form_submitted')) ? eval($hook) : null;

	if ($cat_name == '')
		$cat_name = 'Новая категория';

	$query = array(
		'INSERT'	=> 'cat_name, disp_position, parent_id',
		'INTO'		=> 'pan_boards',
		'VALUES'	=> '\''.$forum_db->escape($cat_name).'\', '.$position.', '.$add_to_cat
	);

	($hook = get_hook('abrd_add_cat_qr_add_cat')) ? eval($hook) : null;
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	// Regenerate the quickjump cache
	if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/cache.php';

	generate_quickjump_cache();

	// Add flash message
	$forum_flash->add_info('Новая категория добавлена');

	($hook = get_hook('abrd_add_cat_pre_redirect')) ? eval($hook) : null;

	redirect(forum_link($forum_url['pan_board_admin']), 'Новая категория добавлена');
}


if (isset($_POST['save']))
{
	$cat_id = intval($_POST['cat_id']);
	$cat_name = forum_trim($_POST['cat_name']);
	$cat_desc = forum_linebreaks(forum_trim($_POST['cat_desc']));
	$parent_id = intval($_POST['parent_id']);

	($hook = get_hook('abrd_save_board_form_submitted')) ? eval($hook) : null;

	if ($cat_name == '')
		message('Имя категории не может быть пустым');

	$cat_desc = ($cat_desc != '') ? '\''.$forum_db->escape($cat_desc).'\'' : 'NULL';

	$query = array(
		'UPDATE'	=> 'pan_boards',
		'SET'		=> 'cat_name=\''.$forum_db->escape($cat_name).'\', cat_desc='.$cat_desc.', parent_id='.$parent_id,
		'WHERE'		=> 'id='.$cat_id
	);

	($hook = get_hook('abrd_save_board_qr_update_cat')) ? eval($hook) : null;
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	// Add flash message
	$forum_flash->add_info('Категория обновлена');

	($hook = get_hook('abrd_save_board_pre_redirect')) ? eval($hook) : null;

	redirect(forum_link($forum_url['pan_board_admin']), 'Категория обновлена');
}


// Update forum positions
else if (isset($_POST['update_positions']))
{
	$positions = array_map('intval', $_POST['position']);

	$query = array(
		'SELECT'	=> 'c.id, c.disp_position',
		'FROM'		=> 'pan_boards AS c',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($cur_board = $forum_db->fetch_assoc($result))
	{
		// If these aren't set, we're looking at a forum that was added after
		// the admin started editing: we don't want to mess with it
		if (isset($positions[$cur_board['id']]))
		{
			$new_disp_position = $positions[$cur_board['id']];

			if ($new_disp_position < 0)
				message($lang_admin_forums['Must be integer']);

			// We only want to update if we changed the position
			if ($cur_board['disp_position'] != $new_disp_position)
			{
				$query = array(
					'UPDATE'	=> 'pan_boards',
					'SET'		=> 'disp_position='.$new_disp_position,
					'WHERE'		=> 'id='.$cur_board['id']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
			}
		}
	}

	// Add flash message
	$forum_flash->add_info('Позиции категорий обновлены');

	($hook = get_hook('abrd_save_board_pre_redirect')) ? eval($hook) : null;

	redirect(forum_link($forum_url['pan_board_admin']), 'Позиции категорий обновлены');
}

// Delete 
if ($action == 'delete' && ($id > 1))
{
	$query = array(
		'SELECT'	=> 'id',
		'FROM'		=> 'pan_board_posts',
		'WHERE'		=> 'cat_id='.$id
	);
//	($hook = get_hook('abrd_qr_get_boards')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$pids = array();
	while ($rows = $forum_db->fetch_assoc($result))
			$pids[] = $rows['id'];
	
	foreach ($pids as $key => $pid)
	{
		$query = array(
			'UPDATE'	=> 'pan_board_posts',
			'SET'		=> 'cat_id=1',
			'WHERE'		=> 'id='.$pid
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
	
	
	$query = array(
		'DELETE'	=> 'pan_boards',
		'WHERE'		=> 'id='.$id
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);


	// Add flash message
	$forum_flash->add_info('Категория удалена');
	redirect(forum_link($forum_url['pan_board_admin']), 'Категория удалена');
}
else if ($action == 'delete' && ($id == 1))
{
	// Add flash message
	$forum_flash->add_info('Невозможно удалить категорию по умолчанию');
	redirect(forum_link($forum_url['pan_board_admin']), 'Невозможно удалить категорию по умолчанию');
}

else if ($action == 'edit' && ($id > 0))
{
	($hook = get_hook('abrd_edit_forum_selected')) ? eval($hook) : null;

	$query = array(
		'SELECT'	=> 'id, cat_name, cat_desc, parent_id',
		'FROM'		=> 'pan_boards',
		'WHERE'		=> 'id='.$id
	);

	($hook = get_hook('abrd_edit_board_qr_get_board_details')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$cur_board = $forum_db->fetch_assoc($result);

	if (is_null($cur_board) || $cur_board === false)
		message($lang_common['Bad request']);

	// Setup the form
	$forum_page['item_count'] = $forum_page['group_count'] = $forum_page['fld_count'] = 0;

	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
		array('Доска объявлений', forum_link($forum_url['pan_board_admin'])),
		'Редактирование'
	);

	($hook = get_hook('abrd_edit_board_pre_header_load')) ? eval($hook) : null;

	define('FORUM_PAGE_SECTION', 'start');
	define('FORUM_PAGE', 'admin-board-edit');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

	($hook = get_hook('abrd_edit_board_output_start')) ? eval($hook) : null;

?>
	<div class="main-subhead">
		<h2 class="hn"><span><?php echo ('Редактирование категории: '.forum_htmlencode($cur_board['cat_name'])) ?></span></h2>
	</div>
	<div class="main-content main-frm">
		<form method="post" class="frm-form" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_board_admin_edit'], $cur_board['id']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_board_admin_edit'], $cur_board['id'])) ?>" />
				<input type="hidden" name="cat_id" value="<?php echo  $cur_board['id'] ?>" />
			</div>
			<div class="content-head">
				<h3 class="hn"><span><?php echo $lang_admin_forums['Edit forum details head'] ?></span></h3>
			</div>
<?php ($hook = get_hook('abrd_edit_board_pre_details_fieldset')) ? eval($hook) : null; ?>
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong>Настройка параметров категории</strong></legend>
<?php ($hook = get_hook('abrd_edit_board_pre_cat_name')) ? eval($hook) : null; ?>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Имя категории</span></label><br />
						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="cat_name" size="35" maxlength="80" value="<?php echo forum_htmlencode($cur_board['cat_name']) ?>" required /></span>
					</div>
				</div>
<?php ($hook = get_hook('abrd_edit_board_pre_cat_desc')) ? eval($hook) : null; ?>
				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="txt-box textarea">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Описание категории</span> <small>Можно использовать HTML</small></label><br />
						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="cat_desc" rows="3" cols="50"><?php echo forum_htmlencode($cur_board['cat_desc']) ?></textarea></span></div>
					</div>
				</div>
<?php 

($hook = get_hook('abrd_edit_board_pre_parent')) ? eval($hook) : null; 

	if ($cur_board['parent_id'] > 0)
	{

?>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box select">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Родительская категория</span></label><br />
						<span class="fld-input"><select id="fld<?php echo $forum_page['fld_count'] ?>" name="parent_id">
<?php

		$query = array(
			'SELECT'	=> 'id, cat_name, cat_desc',
			'FROM'		=> 'pan_boards',
			'WHERE'		=> 'parent_id=0',
		);

		($hook = get_hook('abrd_edit_board_qr_get_categories')) ? eval($hook) : null;
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		while ($cur_cat = $forum_db->fetch_assoc($result))
		{
			$selected = ($cur_cat['id'] == $cur_board['parent_id']) ? ' selected="selected"' : '';
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_cat['id'].'"'.$selected.'>'.forum_htmlencode($cur_cat['cat_name']).'</option>'."\n";
		}

?>
						</select></span>
					</div>
				</div>

<?php 

	}

($hook = get_hook('abrd_edit_board_pre_details_fieldset_end')) ? eval($hook) : null; ?>
			</fieldset>
<?php

($hook = get_hook('abrd_edit_board_details_fieldset_end')) ? eval($hook) : null;

?>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save" value="Сохранить" /></span>
			</div>
		</form>
	</div>
<?php

	($hook = get_hook('abrd_edit_board_end')) ? eval($hook) : null;

	$tpl_temp = forum_trim(ob_get_contents());

	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
}

// Setup the form
$forum_page['fld_count'] = $forum_page['group_count'] = $forum_page['item_count'] = 0;

// Setup breadcrumbs
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
	'Категории доски объявлений'
);

($hook = get_hook('abrd_pre_header_load')) ? eval($hook) : null;

define('FORUM_PAGE_SECTION', 'start');
define('FORUM_PAGE', 'admin-board');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

($hook = get_hook('abrd_main_output_start')) ? eval($hook) : null;

?>
	<div class="main-subhead">
		<h2 class="hn"><span>Добавление новой категории</span></h2>
	</div>
	<div class="main-content main-frm">
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_board_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_board_admin'])) ?>" />
			</div>
<?php ($hook = get_hook('abrd_pre_add_board_fieldset')) ? eval($hook) : null; ?>
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong>Добавление новой категории</strong></legend>
<?php ($hook = get_hook('abrd_pre_new_board_name')) ? eval($hook) : null; ?>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Имя категории</span></label><br />
						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="cat_name" size="35" maxlength="80" required /></span>
					</div>
				</div>
<?php ($hook = get_hook('abrd_pre_new_board_position')) ? eval($hook) : null; ?>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Позиция</span></label><br />
						<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="position" size="3" maxlength="3" /></span>
					</div>
				</div>
<?php ($hook = get_hook('abrd_pre_new_board_cat')) ? eval($hook) : null; ?>
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box select">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Добавить в категорию</span></label><br />
						<span class="fld-input"><select id="fld<?php echo $forum_page['fld_count'] ?>" name="add_to_cat">

<?php echo pan_board_get_cats_name(); ?>

						</select></span>
					</div>
				</div>
<?php ($hook = get_hook('abrd_pre_add_board_fieldset_end')) ? eval($hook) : null; ?>
			</fieldset>
<?php ($hook = get_hook('abrd_add_board_fieldset_end')) ? eval($hook) : null; ?>
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="add_cat" value="Добавить" /></span>
			</div>
		</form>
	</div>

<?php

// Reset fieldset counter
$forum_page['set_count'] = 0;

?>
	<div class="main-subhead">
		<h2 class="hn"><span>Редактирование, удаление и изменение позиции категорий</span></h2>
	</div>
	<div class="main-content main-frm">
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_board_admin']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_board_admin'])) ?>" />
			</div>

<?php
	$forum_page['group_count'] = $forum_page['item_count'] = 0;
	echo pan_board_get_cats_field();
?>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update_positions" value="Обновить позиции" /></span>
			</div>
		</form>
	</div>
<?php

($hook = get_hook('abrd_end')) ? eval($hook) : null;

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';
