<?php 

function pan_board_get_cats($cid=0, $parent=0)
{
	global $forum_db;
	
	$output = array();
	$query = array(
		'SELECT'	=> 'c.id, c.cat_name, c.cat_desc, c.num_posts, c.parent_id',
		'FROM'		=> 'pan_boards AS c',
		'ORDER BY'	=> 'c.cat_name'
	);
	
	if ($cid > 0)
		$query['WHERE'] = 'c.id='.$cid;
	else if ($cid == 0 && ($parent == 1))
		$query['WHERE'] = 'c.parent_id=0';
	
	($hook = get_hook('pan_board_fn_get_cats_qr')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	if ($cid > 0)
		return $forum_db->fetch_assoc($result);
	else
	{
		while ($rows = $forum_db->fetch_assoc($result))
			$output[] = $rows;
	}
	return $output;
}

function pan_board_get_posts($cid=0)
{
	global $forum_db;
	
	$output = array();
	$query = array(
		'SELECT'	=> 'p.id, p.poster_id, p.subject, p.content, p.posted, p.preview, p.price, p.status, c.cat_name',
		'FROM'		=> 'pan_board_posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'pan_boards AS c',
				'ON'			=> 'c.id=p.cat_id'
			)
		),
		'ORDER BY'	=> 'p.posted DESC',
	);
	
	if ($cid > 0)
		$query['WHERE']	= 'p.cat_id='.$cid;
	
	($hook = get_hook('pan_board_fn_get_posts_qr')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rows = $forum_db->fetch_assoc($result))
		$output[] = $rows;
	
	return $output;
}
 
function pan_board_get_post($id)
{
	global $forum_db;

	$query = array(
		'SELECT'	=> 'p.*, c.cat_name, u.username, u.email, u.realname, u.location, u.num_posts, u.registered, u.last_visit, u.avatar',
		'FROM'		=> 'pan_board_posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'pan_boards AS c',
				'ON'			=> 'c.id=p.cat_id'
			),
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> 'u.id=p.poster_id'
			),
		),
		'WHERE'	=> 'p.id='.$id
	);

	($hook = get_hook('pan_board_fn_get_one_post_qr')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	return $forum_db->fetch_assoc($result);
}



function pan_board_create_cats_field_recursive($cats, $parent_id, $sep='')
{
	global $forum_page, $forum_url;
	
	$output = $sep2 = '';
	
	if (is_array($cats) && isset($cats[$parent_id]))
	{
		foreach ($cats[$parent_id] as $cat)
		{
			if ($cat['parent_id'] > 0)
				$sep2 = '- - ';
			
			if (!empty($sep))
				$sep2 .= $sep;
			
			$output .= '<fieldset id="forum'.$cat['id'].'" class="mf-set set'. ++$forum_page['item_count'].' '.(($forum_page['item_count'] == 1) ? 'mf-head' : 'mf-extra').'">
					<legend><span><a href="'.forum_link($forum_url['pan_board_admin_edit'], $cat['id']).'">Редактировать</a> <a href="'.forum_link($forum_url['pan_board_admin_delete'], $cat['id']).'">Удалить</a></span></legend>
					<div class="mf-box">
						<div class="mf-field mf-field1 forum-field">
							<span class="aslabel"></span>
							<span class="fld-input">'.$sep2.forum_htmlencode($cat['cat_name']).'</span>
						</div>
						<div class="mf-field">
							<label for="fld'.++$forum_page['fld_count'].'"><span></span></label><br />
							<span class="fld-input"><input type="number" id="fld'.$forum_page['fld_count'].'" name="position['.$cat['id'].']" size="3" maxlength="3" value="'.$cat['disp_position'].'" /></span>
						</div>
					</div>
				</fieldset>';

			$output .= pan_board_create_cats_field_recursive($cats, $cat['id'], $sep2);
		}
	
	}
	else return null;
	
	return $output;
}

function pan_board_get_cats_field($cid=0)
{
	global $forum_db;
	
	$cats = array();
	$query = array(
		'SELECT'	=> 'c.id, c.cat_name, c.cat_desc, c.num_posts, c.disp_position, c.parent_id',
		'FROM'		=> 'pan_boards AS c',
		'ORDER BY'	=> 'c.disp_position'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rows = $forum_db->fetch_assoc($result)) {
		$cats[$rows['parent_id']][$rows['id']] =  $rows;
	}
	
	return pan_board_create_cats_field_recursive($cats, 0);
}


function pan_board_create_cats_recursive($cats, $parent_id, $sep='', $car_id)
{
	global $forum_page, $forum_url;
	
	$output = $sep2 = '';
	
	if (is_array($cats) && isset($cats[$parent_id]))
	{
		foreach($cats[$parent_id] as $cat)
		{
			$selected = ($car_id == $cat['id'] ) ? ' selected' : '';
			
			if ($cat['parent_id'] > 0)
				$sep2 = '- - ';
			
			if (!empty($sep))
				$sep2 .= $sep;
			
			$output .= "\t\t\t\t\t\t\t".'<option value="'.$cat['id'].'" '.$selected.'>'.$sep2.forum_htmlencode($cat['cat_name']).'</option>'."\n";
			
			$output .= pan_board_create_cats_recursive($cats, $cat['id'], $sep2, $car_id);
		}
	
	}
	else return null;
	
	return $output;
}

function pan_board_get_cats_name($cid=0, $without_cat=1, $sort='', $car_id=0)
{
	global $forum_db;
	
	$cats = array();
	$query = array(
		'SELECT'	=> 'c.id, c.cat_name, c.parent_id',
		'FROM'		=> 'pan_boards AS c',
		'ORDER BY'	=> 'c.disp_position'
	);
	
	if ($sort == 'cat_name')
		$query['ORDER BY'] = 'c.cat_name';
	else
		$query['ORDER BY'] = 'c.disp_position';
	
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($rows = $forum_db->fetch_assoc($result)) {
		$cats[$rows['parent_id']][$rows['id']] =  $rows;
	}
	
	if ($without_cat == 1)
		$output = "\t\t\t\t\t\t\t".'<option value="0">Без категории</option>'."\n";
	
	$output .=pan_board_create_cats_recursive($cats, 0, '', $car_id);
	return $output;
}



function pan_board_categories_recursive($cats, $parent_id)
{
	global $forum_url;
	$output = '';
	
	if (is_array($cats) && isset($cats[$parent_id]) && ($parent_id > 0))
	{
		foreach($cats[$parent_id] as $cat)
		{
			$output .= '<li><a href="'.forum_link($forum_url['pan_board_cid'], $cat['id']).'">'.$cat['cat_name'].'</a> 
				<span>'.$cat['num_posts'].'</span></li>';
			
			if ($parent_id == 0)
				$output .= pan_board_categories_recursive($cats, $cat['id']);
		}
	}
	else if (is_array($cats) && isset($cats[0]))
	{
		foreach($cats[0] as $cat)
		{
			$output .= '<li><a href="'.forum_link($forum_url['pan_board_cid'], $cat['id']).'">'.$cat['cat_name'].'</a> 
				<span>'.$cat['num_posts'].'</span></li>';
		}
	}
	else return null;
	return $output;
}

function pan_board_get_categories($cid=0)
{
	global $forum_db;
	
	$query = array(
		'SELECT'	=> 'c.id, c.cat_name, c.cat_desc, c.num_posts, c.parent_id',
		'FROM'		=> 'pan_boards AS c',
		'ORDER BY'	=> 'c.cat_name'
	);
	
	if ($cid == 0)
		$query['WHERE']	= 'c.parent_id=0';
	
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($rows = $forum_db->fetch_assoc($result)) {
		$cats[$rows['parent_id']][$rows['id']] =  $rows;
	}
	
	return pan_board_categories_recursive($cats, $cid);
}

function pan_board_update_views($id)
{
	global $forum_db;
	
	$query = array(
		'UPDATE'	=> 'pan_board_posts',
		'SET'		=> 'num_views=num_views+1',
		'WHERE'		=> 'id='.$id
	);
	($hook = get_hook('pan_board_fn_update_views_qr')) ? eval($hook) : null;
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
}

function pan_board_update_status($post_info)
{
	global $forum_db, $forum_config;
	
	$time_limit = $post_info['updated'] + ($forum_config['o_pan_board_time_limit'] * 86400);
	
	if (time() > $time_limit)
	{
		$query = array(
			'UPDATE'	=> 'pan_board_posts',
			'SET'		=> 'status=0',
			'WHERE'		=> 'id='.$post_info['id']
		);
		($hook = get_hook('pan_board_fn_update_status_qr')) ? eval($hook) : null;
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
}

function pan_board_html_encode($input)
{
	$output = strip_tags($input, '');
	
	return $output;
}


function pan_board_show_posts($posts_info)
{
	global $forum_user, $forum_url;
	
	echo '<div class="main-content main-frm board-list">';
	
	$i = 0;
	foreach ($posts_info as $post_info)
	{
		if ($post_info['status'] == 1 || $forum_user['g_id'] == FORUM_ADMIN || $post_info['poster_id'] == $forum_user['id'])
		{
			$default_prew_style = '';
			if (empty($post_info['preview'])) {
				$post_info['preview'] = $forum_url['pan_board_ext_url'].'/imgs/default.png';
				$default_prew_style = 'style="opacity: 0.1;"';
			}
			
			$forum_page['board']['edit'] = ($forum_user['g_pan_board_edit'] == 1) ? '<p class="options"><span><a class="sub-option" href="'.forum_link($forum_url['pan_board_edit'], $post_info['id']).'">Редактировать</a></span></p>' : '';
			$forum_page['board']['delete'] = ($forum_user['g_pan_board_delete'] == 1) ? '<p class="options"><span><a class="sub-option" href="'.forum_link($forum_url['pan_board_delete'], $post_info['id']).'">Удалить</a></span></p>' : '';
			
			$forum_page['board']['active'] = ($post_info['status'] == 0 && ($forum_user['g_id'] == FORUM_ADMIN)) ? '<span class="status">Не активированно</span>' : '';
?>
		<div class="ct-box user-box">
			<a class="thumb" href="<?php echo forum_link($forum_url['pan_board_pid'], $post_info['id']) ?>" title="<?php echo $post_info['subject'] ?>">
				<img src="<?php echo $post_info['preview'] ?>" alt="<?php echo $post_info['subject'] ?>" <?php echo $default_prew_style ?>>
			</a>
			<div class="item-info">
				<span class="price"><?php echo number_format($post_info['price'], 0, ',', ' ') ?></span>
				<h3 class="title"><a href="<?php echo forum_link($forum_url['pan_board_pid'], $post_info['id']) ?>"><?php echo $post_info['subject'] ?></a></h3>
				<p><span class="posted"><?php echo format_time($post_info['posted']) ?></span></p>
				<?php echo $forum_page['board']['active'] ?>
				<?php echo (($post_info['poster_id'] == $forum_user['id'] || $forum_user['g_id'] == FORUM_ADMIN) ? $forum_page['board']['delete'] : '') ?>
				<?php echo (($post_info['poster_id'] == $forum_user['id'] || $forum_user['g_id'] == FORUM_ADMIN) ? $forum_page['board']['edit'] : '') ?>
				
			</div>
		</div>
		
<?php
			$i++;
		}
	}
	
	echo '</div>';
	
	if ($i == 0) {
		echo '<div class="main-head">
				<h2 class="hn"><span>Сообщение</span></h2>
			</div>
			<div class="main-content main-message">
				<p>Активных объявлений не найдено.</p>
			</div>';
	}
}

