<?php 

if (!defined('PAN_BOARD_INSTALL')) die();

forum_config_add('o_pan_board_time_limit', '30');
forum_config_add('o_pan_board_indexing', '1');

if (!$forum_db->table_exists('pan_boards'))
{
	$schema = array(
		'FIELDS'		=> array(
			'id'			=> array(
				'datatype'		=> 'SERIAL',
				'allow_null'	=> false
			),
			'cat_name'	=> array(
				'datatype'		=> 'VARCHAR(80)',
				'allow_null'	=> false,
				'default'		=> '\'New forum\''
			),
			'cat_desc'	=> array(
				'datatype'		=> 'TEXT',
				'allow_null'	=> true
			),
			'num_posts'	=> array(
				'datatype'		=> 'MEDIUMINT(8) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'disp_position'	=> array(
				'datatype'		=> 'INT(10)',
				'allow_null'	=> false,
				'default'		=>	'0'
			),
			'parent_id'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=>	'0'
			)
		),
		'PRIMARY KEY'	=> array('id')
	);

	$forum_db->create_table('pan_boards', $schema);
}

if ($forum_db->table_exists('pan_boards'))
{
	$query = array(
		'INSERT'	=> 'cat_name, disp_position, parent_id',
		'INTO'		=> 'pan_boards',
		'VALUES'	=> '\''.$forum_db->escape('Категория').'\', 1, 0'
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
}

if (!$forum_db->table_exists('pan_board_posts'))
{
	$schema = array(
		'FIELDS'		=> array(
			'id'			=> array(
				'datatype'		=> 'SERIAL',
				'allow_null'	=> false
			),
			'poster'		=> array(
				'datatype'		=> 'VARCHAR(200)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'poster_id'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '1'
			),
			'subject'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> false,
				'default'		=> '\'\''
			),
			'content'		=> array(
				'datatype'		=> 'TEXT',
				'allow_null'	=> true
			),
			'posted'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> true
			),
			'updated'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> true
			),
			'num_views'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'price'			=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'phone'			=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> true
			),
			'preview'		=> array(
				'datatype'		=> 'VARCHAR(255)',
				'allow_null'	=> true
			),
			'status'		=> array(
				'datatype'		=> 'TINYINT(1)',
				'allow_null'	=> false,
				'default'		=> '0'
			),
			'cat_id'		=> array(
				'datatype'		=> 'INT(10) UNSIGNED',
				'allow_null'	=> false,
				'default'		=> '0'
			)
		),
		'PRIMARY KEY'	=> array('id')
	);

	$forum_db->create_table('pan_board_posts', $schema);
}

if (!$forum_db->field_exists('groups', 'g_pan_board_view'))
	$forum_db->add_field('groups', 'g_pan_board_view', 'TINYINT(1)', false, '1');

if (!$forum_db->field_exists('groups', 'g_pan_board_add'))
	$forum_db->add_field('groups', 'g_pan_board_add', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('groups', 'g_pan_board_edit'))
	$forum_db->add_field('groups', 'g_pan_board_edit', 'TINYINT(1)', false, '0');

if (!$forum_db->field_exists('groups', 'g_pan_board_delete'))
	$forum_db->add_field('groups', 'g_pan_board_delete', 'TINYINT(1)', false, '0');

// set default settings for admin
$query = array(
	'UPDATE'	=> 'groups',
	'SET'		=> 'g_pan_board_view=1, g_pan_board_add=1, g_pan_board_edit=1, g_pan_board_delete=1',
	'WHERE'		=> 'g_id=1'
);
$forum_db->query_build($query) or error(__FILE__, __LINE__);

if (!file_exists(FORUM_ROOT.'board.php')) {
	$old_file = FORUM_ROOT.'extensions/pan_board/board.php';
	$new_file = FORUM_ROOT.'board.php';
	copy($old_file, $new_file);
}

